"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var convertToCSSPrefix_1 = require("./utils/convertToCSSPrefix");
;
function transit(value, duration, timing, delay) {
    var ret = [value];
    ret.transitParams = {
        duration: duration,
        timing: timing || "ease",
        delay: delay !== undefined ? delay : 0,
    };
    return ret;
}
exports.transit = transit;
function resolveTransit(style, extraDelay) {
    if (extraDelay === void 0) { extraDelay = 0; }
    var transition = "";
    var processedStyle = __assign({}, style);
    for (var property in style) {
        var val = style[property];
        if (Array.isArray(val) && val.transitParams) {
            var _a = val.transitParams, duration = _a.duration, timing = _a.timing, delay = _a.delay;
            if (transition !== "") {
                transition += ", ";
            }
            transition += convertToCSSPrefix_1.default(property) + " " + duration + "ms " + timing + " " + (delay + extraDelay) + "ms";
            processedStyle[property] = val[0];
        }
    }
    if (transition) {
        processedStyle.transition = transition;
    }
    return processedStyle;
}
exports.resolveTransit = resolveTransit;

//# sourceMappingURL=transit.js.map
